import { Plugin } from 'vite';

declare function qrcode(options?: PluginOptions): Plugin;
interface PluginOptions {
    /**
     * filter list of shown QR codes. Useful if you have multiple interfaces and only need one
     *
     *  examples:
     *    ip => ip.startsWith('192.')
     *    ip => !ip.startsWith('172.)
     *    ip => ip === '192.168.1.70'
     *
     * @param ip {string} ip address
     * @returns {boolean}
     */
    filter?: (ip: string) => boolean;
}

export { PluginOptions, qrcode };
